=== debian/changelog ===
arm-trusted-firmware (2.10.0+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:20:51 +1100

arm-trusted-firmware (2.10.0+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:23:05 +0000

arm-trusted-firmware (2.10.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches: Drop patches applied upstream.
  * debian/patches: Refresh patch to use ldflags.
  * debian/copyright: Update for 2.10.0.

 -- Vagrant Cascadian <vagrant@debian.org>  Sun, 03 Dec 2023 17:25:38 -0800
