=== debian/changelog ===
arm-trusted-firmware (2.10.10+dfsg-1) unstable; urgency=medium

  * New upstream LTS release. (Closes: #1071959)

  [ Diederik de Haas ]
  * debian/patches: Don't ignore '*.patch' files in debian/patches
  * d/watch: Switch to mode=git

  [ Vagrant Cascadian ]
  * debian/patches: Disable fatal warnings passed via ASFLAGS to
    workaround build failure.  Thanks to Marek
    Vasut. https://bugs.debian.org/1091147
  * debian/control: Update to Standards Version 4.7.0.
  * debian/copyright: Update for 2.10.10.

  [ Martyn Welch ]
  * d/rules: Add k3 target

 -- Vagrant Cascadian <vagrant@debian.org>  Wed, 08 Jan 2025 14:32:46 -0800
