=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 VERBOSE=1
 endif
 
-platforms := g12a gxbb sun50i_a64 sun50i_h6 rcar rk3328 rk3399 rpi3 rpi4 imx8mn imx8mm
+platforms := g12a gxbb sun50i_a64 sun50i_h6 rcar rk3328 rk3399 rpi3 rpi4 imx8mn imx8mm k3
 # Disable building of imx8mq, as it is not well supported upstream.
 #platforms_nodebug := imx8mq
 
@@ -32,6 +32,8 @@
 imx8mm_uart1_assigns := IMX_BOOT_UART_BASE=0x30860000
 imx8mm_uart3_assigns := IMX_BOOT_UART_BASE=0x30880000
 imx8mm_uart4_assigns := IMX_BOOT_UART_BASE=0x30A60000
+
+k3_assigns := TARGET_BOARD=lite
 
 # TF-A's regulator setup breaks Ethernet on some H6 boards,
 # so make it optional by having two subplatforms:
@@ -59,6 +61,8 @@
 	$(eval subplatforms := $(if $($(platform)_subplatforms), $($(platform)_subplatforms), $(platform)))
 	$(eval targets := $(if $($(platform)_targets), $($(platform)_targets), bl31.bin))
 	$(eval make_target := $(if $($(platform)_make_target), $($(platform)_make_target), bl31))
+	# board needs to be set to "lite" for k3 platform
+	$(eval board := $(if $(filter k3,$(platform)),lite,))
 	$(foreach subplatform, $(subplatforms), \
 		CROSS_COMPILE=aarch64-linux-gnu- CFLAGS=--param=min-pagesize=0 LDFLAGS= TF_LDFLAGS=--no-warn-rwx-segments dh_auto_build -- V=$(VERBOSE) DEBUG=$(debug) $($(subplatform)_assigns) PLAT=$(platform) $(make_target) ; \
 		$(foreach target, $(targets), \
