=== debian/changelog ===
arm-trusted-firmware (2.12.0+dfsg-2) unstable; urgency=medium

  [ Martyn Welch ]
  * d/rules: Add k3 target

  [ Vagrant Cascadian ]
  * debian/rules: Enable building rockchip rk3568.
  * debian/rules: Enable building rockchip rk3588.
  * debian/patches: Add fixes from upstream to fix building rcar targets.
  * debian/rules: Re-enable rcar targets.
  * debian/patches: Add patch from upstream fixing warnings when building
    rk3399.
  * debian/rules: Sort platforms.
  * salsa-ci: Allow crossbuild-arm64 to fail.

  [ Andreas Henriksson ]
  * debian/rules: Enable building imx8mp (Closes: #1092909)

  [ Vagrant Cascadian ]
  * debian/rules: Sort platforms even better.

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 20 Jan 2025 16:37:31 -0800

arm-trusted-firmware (2.12.0+dfsg-1) experimental; urgency=medium

  * New upstream release. (Closes: #1074431, #1076042)
    Fixes CVE-2024-6563 CVE-2024-6564 CVE-2024-6287 CVE-2024-6285

  [ Diederik de Haas ]
  * debian/patches: Don't ignore '*.patch' files in debian/patches
  * d/watch: Switch to mode=git

  [ Vagrant Cascadian ]
  * debian/patches: Refresh use-ldflags-with-fiptool-and-cert-create.
  * Remove unlicensed binary
    plat/arm/board/common/swd_rotpk/arm_swd_rotpk_rsa_sha256.bin
  * debian/patches: Add patch working around undefined "PLAT_MSG".
  * debian/patches: Disable fatal warnings passed via ASFLAGS to
    workaround build failure.  Thanks to Marek
    Vasut. https://bugs.debian.org/1091147
  * debian/rules: Drop passing --no-warn-rwx-segments via TF_LDFLAGS. It
    is now detected in the upstream code weather this flag is supported.
  * debian/copyright: Update for 2.12.0.
  * debian/rules: Temporarily disable building of rcar target.
  * debian/control: Update to Standards Version 4.7.0.

 -- Vagrant Cascadian <vagrant@debian.org>  Tue, 07 Jan 2025 16:11:32 -0800
