=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: arm-trusted-firmware
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Vagrant Cascadian <vagrant@debian.org>
-Standards-Version: 4.6.2
+Maintainer: Vagrant Cascadian <vagrant@debian.org>
+Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13),
  gcc-arm-none-eabi [arm64],
  binutils-arm-none-eabi [arm64],
